# 
# This program is free software: you can redistribute it and/or modify it under 
# the terms of the GNU General Public License as published by 
# the Free Software Foundation, either version 3 of the License, 
# or (at your option) any later version.
# 
# 
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
# See the GNU General Public License for more details.
# 
# 
# You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <https://www.gnu.org/licenses/>.
# 
# Copyright © 2019 Cloud Linux Software Inc.
# 
# This software is also available under ImunifyAV commercial license,
# see <https://www.imunify360.com/legal/eula>

package Cpanel::Config::ConfigObj::Driver::Imunify360::META;

if( -e '/usr/local/cpanel/Cpanel/Config/ConfigObj/Interface/Config/Version') {
    eval('use parent qw(Cpanel::Config::ConfigObj::Interface::Config::Version::v1);');
}

our $VERSION = '1.0';
use Cpanel::LoadModule ();

use strict;

sub meta_version {
    return 1;
}

sub get_driver_name {
    return 'Imunify360_driver';
}

sub content {
    my ($locale_handle) = @_;

    my $content = {
        'vendor' => 'CloudLinux Zug GmbH',
        'url'    => 'imunify360.com',
        'name'   => {
            'short'  => 'Imunify360 Driver',
            'long'   => 'Driver for Imunify360 Plugin',
            'driver' => get_driver_name(),
        },
        'since'    => 'cPanel & WHM version 11.32.4',
        'abstract' => "Imunify360 Driver",
        'version'  => $Cpanel::Config::ConfigObj::Driver::LveManager::VERSION,
    };

    if ($locale_handle) {
        $content->{'abstract'} = $locale_handle->maketext("Imunify360 driver.");
    }

    return $content;
}

1;
