#!/usr/local/cpanel/3rdparty/bin/perl

BEGIN { unshift @INC, '/usr/local/cpanel', '/usr/local/cpanel/whostmgr/cgi/imunify/handlers'; }

use strict;
use warnings;
use locale ':not_characters';   # utf-8

use Cpanel::LiveAPI();
use Cpanel::JSON;
use Data::Dumper;
use CGI;

use Imunify::File;
use Imunify::Render;
use Imunify::Wrapper;
use Imunify::Exception;
use Imunify::Utils;

#use CGI::Carp qw(fatalsToBrowser); # uncomment to debug 500 error

my $panel = Cpanel::LiveAPI->new();

eval {
    my $cgi = CGI->new;
    my $json = $cgi->param('POSTDATA');

    if (!$json) {
        main();
    } else {
        my $request = Cpanel::JSON::Load($json);
        my $command = $request->{'command'} || 'default';
        if ($command eq 'commandIE') {
            Imunify::Wrapper::imunfyEmailRequest($request, 0);
        } else {
            Imunify::Wrapper::request($request, 0);
        }
    }

    $panel->end();
};

if ($@) {
    if (ref($@) && $@->can('asJSON')) {
        $@->asJSON();
    } else {
        die Imunify::Exception->new($@)->asJSON();
    }
}

sub main {
    my $i360ieExist = 0;
    if (-e '/var/run/imunifyemail/quarantine.sock') {
        $i360ieExist = 1;
    }
    print "Content-type: text/html; charset=utf-8\n\n";
    print $panel->header('');

    print qq{<script>var i360role = "client"; var i360userName = "$ENV{REMOTE_USER}"; var i360ieExist = "$i360ieExist"</script>};

    Imunify::Render::assets('client');

    print '<div class="i360-app i360-cpanel i360-client"><app>Loading...</app></div>';
    print $panel->footer();
}
