# 
# This program is free software: you can redistribute it and/or modify it under 
# the terms of the GNU General Public License as published by 
# the Free Software Foundation, either version 3 of the License, 
# or (at your option) any later version.
# 
# 
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
# See the GNU General Public License for more details.
# 
# 
# You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <https://www.gnu.org/licenses/>.
# 
# Copyright © 2019 Cloud Linux Software Inc.
# 
# This software is also available under ImunifyAV commercial license,
# see <https://www.imunify360.com/legal/eula>

package Imunify::Acls;

use Whostmgr::ACLS();

sub checkPermission
{
    if (_isAdmin()
        || (_isReseller()  && _isAvailablePluginForReseller())
    ) {
        return 1;
    }
    return 0;
}

sub _getUser {
    return $ENV{'REMOTE_USER'};
}

sub _isAdmin
{
    if (Whostmgr::ACLS::hasroot()) {
        return 1;
    }
    return 0;
}

sub _isReseller
{
    my $RESELLER_LIST_FILE = '/var/cpanel/resellers';
    my $result = 0;
    if (-e $RESELLER_LIST_FILE) {
        open my $f, $RESELLER_LIST_FILE or die "Could not open $RESELLER_LIST_FILE: $!";

        while( my $line = <$f>)  {
            my @data = split /:/, $line;
            if (_getUser() eq $data[0]) {
                $result = 1;
                last;
            }
        }
        close $f;
    }
    return $result;
}

sub _isAvailablePluginForReseller
{
    if (Whostmgr::ACLS::checkacl('software-imunify360') ) {
        return 1;
    }
    return 0;
}

1;