# 
# This program is free software: you can redistribute it and/or modify it under 
# the terms of the GNU General Public License as published by 
# the Free Software Foundation, either version 3 of the License, 
# or (at your option) any later version.
# 
# 
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
# See the GNU General Public License for more details.
# 
# 
# You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <https://www.gnu.org/licenses/>.
# 
# Copyright © 2019 Cloud Linux Software Inc.
# 
# This software is also available under ImunifyAV commercial license,
# see <https://www.imunify360.com/legal/eula>

package Imunify::File;

use strict;
use warnings FATAL => 'all';
use File::Copy;
use File::Basename;
use Fcntl qw(SEEK_SET);
use Encode;
use Imunify::Exception;


# default 100 KB
use constant READ_LENGTH => 1024 * 100;

sub get {
    my ($file) = @_;
    die Imunify::Exception->new("File not found.") if !-e $file;
    open FH, '<:encoding(UTF-8)', $file || die Imunify::Exception->new("Unable to open file.");

    return do {
        local $/;
        <FH>;
    };
}

1;