# 
# This program is free software: you can redistribute it and/or modify it under 
# the terms of the GNU General Public License as published by 
# the Free Software Foundation, either version 3 of the License, 
# or (at your option) any later version.
# 
# 
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
# See the GNU General Public License for more details.
# 
# 
# You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <https://www.gnu.org/licenses/>.
# 
# Copyright © 2019 Cloud Linux Software Inc.
# 
# This software is also available under ImunifyAV commercial license,
# see <https://www.imunify360.com/legal/eula>

package Imunify::Icontact::Base;

use strict;

use Cpanel::DIp::MainIP;
use Cpanel::Hostname;
use Imunify::Utils;

use parent qw(
    Cpanel::iContact::Class
);

sub _my_args {
    return qw();
}

sub _required_args {
    my ($class) = @_;

    return (
        $class->SUPER::_required_args(),
        $class->_my_args(),
    );
}

sub _template_args {
    my ($class) = @_;
    my $base_url = 'cgi/imunify/handlers/index.cgi#/'
        . ((Imunify::Utils->getPluginName() eq 'ImunifyAV') ? 'AV/' : '360/');

    # in old versions of cPanel there is no getmainsharedip()
    my $mainip = Cpanel::DIp::MainIP->can('getmainsharedip')
        ? Cpanel::DIp::MainIP->getmainsharedip()
        : Cpanel::DIp::MainIP->getpublicmainserverip();

    my %template_args = (
        $class->SUPER::_template_args(),
        'hostname' => Cpanel::Hostname::gethostname(),
        'mainip'   => $mainip,
        'base_url'   => $base_url,
        map { $_ => $class->{'_opts'}{$_} } $class->_my_args(),
    );

    return %template_args;
}

1;
