# 
# This program is free software: you can redistribute it and/or modify it under 
# the terms of the GNU General Public License as published by 
# the Free Software Foundation, either version 3 of the License, 
# or (at your option) any later version.
# 
# 
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
# See the GNU General Public License for more details.
# 
# 
# You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <https://www.gnu.org/licenses/>.
# 
# Copyright © 2019 Cloud Linux Software Inc.
# 
# This software is also available under ImunifyAV commercial license,
# see <https://www.imunify360.com/legal/eula>

package Imunify::Wrapper;

use strict;
use warnings FATAL => 'all';
use Encode;
use Data::Dumper;
use File::HomeDir;
use File::Basename;
use IO::Handle;

use Imunify::Exception;
use Imunify::Render;
use Imunify::Utils;
use Imunify::Config;
use Cpanel::JSON;

#use CGI::Carp qw(fatalsToBrowser); # uncomment to debug 500 error

sub execute {
    my ($request, $isWHM) = @_;
    my %data = ();

    $data{'command'} = \@{$request->{'method'}};
    $data{'params'} = $request->{'params'};
    $data{'params'}{'remote_addr'} = $ENV{REMOTE_ADDR};

    return Imunify::Utils::execute('execute', \%data, $isWHM);
}

sub request {
    my ($request, $isWHM) = @_;
    my $response = execute($request, $isWHM);
    Imunify::Render::JSONHeader(Imunify::Render->HTTP_STATUS_OK);
    print $response;
}

sub imunfyEmailRequest {
    my ($request, $isWHM) = @_;
    my %data = ();
    $data{'username'} = $ENV{REMOTE_USER};
    $data{'command'} = \@{$request->{'method'}};
    $data{'params'} = $request->{'params'};
    my $response = Imunify::Utils::execute('imunifyEmail', \%data, $isWHM);
    Imunify::Render::JSONHeader(Imunify::Render->HTTP_STATUS_OK);
    print $response;
}

sub upload {
    my ($cgi, $isWHM) = @_;
    my ($tmpPath);
    my %data = (
        'files' => {},
    );

    foreach my $file ($cgi->param('files[]')) {
        $tmpPath = $cgi->tmpFileName($file);
        $data{'files'}{$tmpPath} = "$file";
    }

    return Imunify::Utils::execute('uploadFile', \%data, $isWHM);
}

1;
